package com.eactive.eai.batch.job.jobItem.bokjj;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_BOKJJ_0600 extends DefaultTelegram implements TelegramService {

    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    //>> 업무관리정보
    private final String OpCode_start          = "001";    //개별 업무 개시
    private final String OpCode_resume         = "002";    //파일 송수신 계속
    private final String OpCode_unit_end       = "003";    //개별업무 종료
    private final String OpCode_all_end        = "004";    //개별업무 종료

    private Properties telegramInfo;

    /**
     * 생성자
     */
    public SEND_BOKJJ_0600() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;

            if ( this.getFldOpCode().equals("001") ){
                try {
    				long sleepTime = Long.parseLong(telegramInfo.getProperty(TelegramKeys.SLEEP_TIME));
    				Thread.sleep(sleepTime); 
    			} catch (Exception e) {
    				logger.debug(e.getMessage(), e);
    			}
            }

            if ( OpCode_start.equals(getFldOpCode()) || OpCode_resume.equals(getFldOpCode())) {
                this.batchDoc.getBatchMsg().getBody().setBlockNum(0);
                this.batchDoc.getBatchMsg().getBody().setSeqNum(0);
                if (!setIdPass()) return false;
            }

            //전문송신 Byte 수 : 공통부 중 1 ~ 6번 길이(21)와 개별부 길이의 합 (전체 전문 길이 - 5 )
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);

            //업무구분코드 - FTP
            compileField(1, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[1]);

            //기관코드 - 『기본설계서(온라인)』 <별첨3> 참조
            compileField(2, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[2]);

            //전문종별코드.
            compileField(3, this.getFldTelegramType(), this.al_FieldProps[3]);

            //거래구분코드
            compileField(4, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[4]);

            //송수신 FLAG : 전문 발생 기관을 구분하여  아래의 값을 SET한다.
            //             C  : 한국은행 송신,  O  : 참가기관 송신
            compileField(5, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[5]);

            //응답코드
            compileField(6, this.getResolveResponseCode(), this.al_FieldProps[6]);
            // 여기 까지 공통부

            //송수신 업무 구분코드.
            //“S”: 파일 송신업무 관련 전문 (한국은행 → 은행)
            //“R”: 파일 수신업무 관련 전문 (은행 → 한국은행)
            compileField(7, getFldTrClass() , this.al_FieldProps[7]);


            //전문 전송일시 YYYYMMDDHHMMSS     기관에서 수신 시간 이후에  미수신자료를 수신코자 할 때는 전송일자와 상수(YYYYMMDD999999)를 SET한다.
            // 파일의 기준일자가 당일인지 체크한다.
            String baseDate = batchDoc.getBatchMsg().getHeader().getBaseDate();

            if (  !baseDate.equals(TelegramKeys.getYYYYMMDD())) {
                compileField(8, baseDate + "9999999", this.al_FieldProps[8]);
            } else {
                compileField(8, TelegramKeys.getYYYYMMddHHmmss(), this.al_FieldProps[8]);
            }

            //업무 관리 정보 - 파일전송업무 관리를 위한 정보로 아래의 값 중 하나를 Set 한다.
            // “001”: 개별 업무 개시 “002”: 파일 송수신 계속
            // “003”: 개별 업무 종료 “004”: 전업무종료 요구/요구응답
            compileField(9, this.getFldOpCode(), this.al_FieldProps[9]);

            //Block-NO
            compileField(10, ""+this.batchDoc.getBatchMsg().getBody().getBlockNum() , this.al_FieldProps[10]);

            //Sequence-NO
            compileField(11, ""+this.batchDoc.getBatchMsg().getBody().getSeqNum() , this.al_FieldProps[11]);

            //송신자명 파일전송업무의 책임이 있는 사람의 나타내는 ID를 Set한다.
            compileField(12, batchDoc.getBatchMsg().getHeader().getUserID(), this.al_FieldProps[12]);

            //송신자 암호 (정당한 송신자 확인을 위한 쌍방간 합의된 암호
            compileField(13, batchDoc.getBatchMsg().getHeader().getUserPassword(), this.al_FieldProps[13]);

            //송신 집계 내역
            if ( OpCode_unit_end.equals(getFldOpCode())) {
                compileField(14, batchDoc.getBatchMsg().getBody().getSendSummary(), this.al_FieldProps[14]);
            }else if ( OpCode_all_end.equals(getFldOpCode())){
                compileField(14, calculateSendSum(), this.al_FieldProps[14]);
            }else{
                compileField(14, "", this.al_FieldProps[14]);
            }

            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;

        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<7; i++) { //신한은망 전문의 헤더는 응답코드까지 임.
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=7; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i < 1 ; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }
    private String calculateSendSum(){
        String sendSum = "";
        try {
//            String prevSum = batchDoc.getEAIBatchMessage().getBody().getSendSummary();
            // 0701 0006180 03 0000002 02 0000001 04 0000001 06 0000001 05 000002 00 70000001
            //      4         13         22          31        40         49        56
//            int fileNum = Integer.parseInt( prevSum.substring(0,2));
//            long sendCnt = 0;
//            for ( int inx=0; inx<fileNum; inx++){
//                sendCnt += Integer.parseInt( prevSum.substring(4+ 9*inx,11+9*inx));
//            }
//            sendSum = "01DSS0" + ( ( 10000000 + sendCnt ) + "" ).substring(1,8);
            // 송신 자료 총 건수가 아니고 송신 파일 개수를 보내 줘야 한다.
            // 2008년 12월 18일 김정(560-1542 )
            sendSum = "01DSS0" + batchDoc.getBatchMsg().getBody().getSendSummary().substring(0,2);
        } catch (Exception e) {


        }
        return sendSum;
    }

    private boolean setIdPass(){
        try {
            String hdrInfo = batchDoc.getBatchMsg().getHeader().getHdrInfoName();
            batchDoc.getBatchMsg().getHeader().setUserID(hdrInfo.substring(38,54));
            batchDoc.getBatchMsg().getHeader().setUserPassword(hdrInfo.substring(54,70));
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(6);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getFieldValueString(9);
    }
}